/*
 * @Description: Description
 * @Author: ranli
 * @Date: 2020-09-22 15:02:46
 * @LastEditTime: 2022-10-19 14:26:28
 * @LastEditors: ranli
 */
var fs = require("fs");
const my_file = require("./../../util/file");
require("./../../router/util/common.js");

function writeConfig(TAR_DIR, config, CON_DIR) {
  let files = fs.readdirSync(CON_DIR);
  let file_content = "";
  let file_type = ".sh";
  let file_name = "";
  let domain = config.h5.split(".")[1];
  files.forEach((item) => {
    file_name = item.split(".")[0];
    switch (item) {
      case "profile.txt":
        file_type = ".js";
        file_content = fs
          .readFileSync(CON_DIR + "/" + item)
          .toString()
          .replace(/{{http_url}}/g, config.gateway);
        break;
    }
    fs.writeFileSync(TAR_DIR + file_name + file_type, file_content);
  });
}



function writePage(TAR_DIR, config, TEM_DIR) {
  let files = fs.readdirSync(TEM_DIR);
  let time_arry = new Date().Format("yyyy-MM-dd").split("-"); //"2020/9/28"
  let time = `${time_arry[2]}th ${my_file.getMonthE(time_arry[1])} ${time_arry[0]} `;
  let name_upper = config.appName.toUpperCase();
  let template_txt;
  let file_path = "/";
  files.forEach((item) => {
    switch (item) {
      case "PrivacyPolicy.txt":
        template_txt = fs
          .readFileSync(TEM_DIR + "/" + item)
          .toString()
          .replace(/{{appName}}/g, config.appName)
          .replace(/{{OrganizationNames}}/g, config.OrganizationNames)
          .replace(/{{update_time}}/g, time)
          .replace(/{{Email}}/g, config.email);
        file_path = "/PrivacyPolicy/";

        break;
      case "TermsAndConditions.txt":
        template_txt = fs
          .readFileSync(TEM_DIR + "/" + item)
          .toString()
          .replace(/{{appName}}/g, config.appName)
          .replace(/{{OrganizationNames}}/g, config.OrganizationNames)
          .replace(/{{update_time}}/g, time)
          .replace(/{{appName_upperCase}}/g, name_upper)
          .replace(/{{Email}}/g, config.email);
        file_path = "/TermsAndConditions/";
        break;
      case "APK.txt":
        template_txt = fs
          .readFileSync(TEM_DIR + "/" + item)
          .toString()
          .replace(/{{appName}}/g, config.appName);
        file_path = "/Promotion/APK/";
        break;
      case "H5.txt":
        template_txt = fs
          .readFileSync(TEM_DIR + "/" + item)
          .toString()
          .replace(/{{appName}}/g, config.appName);
        file_path = "/Promotion/H5/";
        break;
      case "FeedbackDetail.txt":
        template_txt = fs.readFileSync(TEM_DIR + "/" + item).toString();
        file_path = "/Feedback/FeedbackDetail/";
        break;
      case "FeedbackList.txt":
        template_txt = fs.readFileSync(TEM_DIR + "/" + item).toString();
        file_path = "/Feedback/FeedbackList/";
        break;
      case "index.txt":
        template_txt = fs
          .readFileSync(TEM_DIR + "/" + item)
          .toString()
          .replace(/{{appName}}/g, config.appName);
        file_path = "/";
        break;
    }
    my_file.mkdirPath(TAR_DIR + file_path)
    fs.writeFileSync(TAR_DIR + file_path + "index.vue", template_txt);
  });
}


function writeModule(config, project_dirname, current_dirname, SOURCE_DIR) {
  try {
    if (config) {
      //模板文件夹
      const template_Dir = `${current_dirname}/template/${config.local}`;
      const config_Dir = current_dirname + "/config";
      //目标文件夹pages
      const target_Dir = project_dirname + SOURCE_DIR;
      // 写入配置文件
      writeConfig(project_dirname, config, config_Dir);
      //删除page下面的文件夹
      my_file.delDir(target_Dir);
      writePage(target_Dir, config, template_Dir);
    } else {
      //失败就抛出异常，具体代码操作按实际需求来写
      throw new Error("读取配置文件website.json格式异常, 请检查website配置。");
    }
  } catch (error) {
    //失败就抛出异常，具体代码操作按实际需求来写
    throw new Error("读取配置文件website.json格式异常, 请检查website配置。");
  }
}

module.exports = {
  writeModule,
};
