const os = require("os");
var fs = require("fs");

function getMonthE(NUM) {
  let E = "";
  switch (NUM) {
    case "01":
      E = "January";
      break;
    case "02":
      E = "February";
      break;
    case "03":
      E = "March";
      break;
    case "04":
      E = "April";
      break;
    case "05":
      E = "May";
      break;
    case "06":
      E = "June";
      break;
    case "07":
      E = "July";
      break;
    case "08":
      E = "August";
      break;
    case "09":
      E = "September";
      break;
    case "10":
      E = "October";
      break;
    case "11":
      E = "November";
      break;
    case "12":
      E = "December";
      break;
  }

  return E;
}

function delDir(path) {
  let files = [];
  if (fs.existsSync(path)) {
    files = fs.readdirSync(path);
    files.forEach((file, index) => {
      let curPath = path + "/" + file;
      if (fs.statSync(curPath).isDirectory()) {
        delDir(curPath); //递归删除文件夹
      } else {
        fs.unlinkSync(curPath); //删除文件
      }
    });
    fs.rmdirSync(path);
  }
}
/**
 * 判读路径是否存在,如不存在创建文件夹
 * @param pathStr 参数要用path.join()拼接,项目下的相对路径
 * @return projectPath 返回绝对路径,可要可不要
 */
function mkdirPath_windows(pathStr) {
  var projectPath = "";
  var tempDirArray = pathStr.split("/");
  for (var i = 0; i < tempDirArray.length; i++) {
    if (tempDirArray[i]) {
      if (i == 0) {
        projectPath = projectPath + tempDirArray[i];
      } else {
        projectPath = projectPath + "/" + tempDirArray[i];
      }

      if (fs.existsSync(projectPath)) {
        var tempstats = fs.statSync(projectPath);
        if (!tempstats.isDirectory()) {
          fs.unlinkSync(projectPath);
          fs.mkdirSync(projectPath);
        }
      } else {
        fs.mkdirSync(projectPath);
      }
    }
  }
  return projectPath;
}

/**
 * 判读路径是否存在,如不存在创建文件夹
 * @param pathStr 参数要用path.join()拼接,项目下的相对路径
 * @return .
 *  返回绝对路径,可要可不要
 */
function mkdirPath_linux(pathStr) {
  var projectPath = "/";
  var tempDirArray = pathStr.split("/");
  for (var i = 0; i < tempDirArray.length; i++) {
    if (tempDirArray[i]) {
      projectPath = projectPath + "/" + tempDirArray[i];
      if (fs.existsSync(projectPath)) {
        var tempstats = fs.statSync(projectPath);
        if (!tempstats.isDirectory()) {
          fs.unlinkSync(projectPath);
          fs.mkdirSync(projectPath);
        }
      } else {
        fs.mkdirSync(projectPath);
      }
    }
  }
  return projectPath;
}

function mkdirPath(dir) {
  if (os.type() == "Windows_NT") {
    //windows
    //2. fs.mkdirSync 创建目录
    mkdirPath_windows(dir);
  } else if (os.type() == "Darwin") {
    //mac
    throw new Error("不支持当前系统。请使用Windows或者Linux");
  } else if (os.type() == "Linux") {
    //Linux
    mkdirPath_linux(dir);
  } else {
    //不支持提示
    throw new Error("不支持当前系统。请使用Windows或者Linux");
  }
}
module.exports = {
  delDir,
  mkdirPath,
  getMonthE
};
