/*
 * @Description: Description
 * @Author: ranli
 * @Date: 2020-09-22 15:02:46
 * @LastEditTime: 2022-05-13 11:28:36
 * @LastEditors: ranli
 */
var fs = require("fs");
const my_file = require("./../../util/file");

function writeConfig(TAR_DIR, config, CON_DIR) {
  let files = fs.readdirSync(CON_DIR);
  let file_content = "";
  let file_type = ".sh";
  let file_name = "";
  let domain = config.h5.split(".")[1];
  files.forEach((item) => {
    file_name = item.split(".")[0];
    switch (item) {
      case "profile.txt":
        file_type = ".js";
        file_content = fs
          .readFileSync(CON_DIR + "/" + item)
          .toString()
          .replace(/{{http_url}}/g, config.gateway);
        break;
    }
    fs.writeFileSync(TAR_DIR + file_name + file_type, file_content);
  });
}

function writePage(TAR_DIR, config, TEM_DIR) {
  // setp1:获取配置object config
  //setp2:使用配置文件生成路由文件
  //setp3: 把生成的文件放到pages下面去
  //获取模板文件文本
  let template_file_text = fs.readFileSync(TEM_DIR + '/index.vue').toString();
  let pages = config.pages
  for (const key in pages) {
    if (Object.hasOwnProperty.call(pages, key)) {
      const element = pages[key];
      let page_content = template_file_text.replace(/{{editor-result-text-name}}/g, element.name).replace(/{{editor-result-text-context}}/g, element.context)
      my_file.mkdirPath(TAR_DIR + '/' + element.name);
      fs.writeFileSync(TAR_DIR + '/' + element.name + "/index.vue", page_content);
    }
  }
}

//输入配置生成页面
function writeModule(config, project_dirname, current_dirname, SOURCE_DIR) {
  try {
    if (config) {
      //模板文件夹
      const template_Dir = `${current_dirname}/template`;
      //目标文件夹pages
      const target_Dir = project_dirname + SOURCE_DIR;
      const config_Dir = current_dirname + "/config";
      // 写入配置文件 
      writeConfig(project_dirname, config, config_Dir);
      //删除page下面的文件夹
      my_file.delDir(target_Dir);
      writePage(target_Dir, config, template_Dir);

    } else {
      //失败就抛出异常，具体代码操作按实际需求来写
      throw new Error("读取配置文件website.json格式异常, 请检查website配置。");
    }
  } catch (error) {
    //失败就抛出异常，具体代码操作按实际需求来写
    // throw new Error("读取配置文件website.json格式异常, 请检查website配置。");
    throw new Error(error);
  }
}

module.exports = {
  writeModule,
};